#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include "config.h"

/*
Esercizio3
	un programmino di esempio sull'uso dei socket (in modalita` TCP e
	UDP) e le configurazioni client/server in C

client_tcp.c
	programma client, non fa altro che connettersi all'host specificato
	nella commandline (porta hardwired) e, se la connessione e` andata
	a buon fine, spedire un comando specificato nella comandline e
	aspettarsi l'output di questo dalla stessa connessione.

Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/


void main( int argc, char *argv[]) {

char	cmd[CLEN] = "\0",		// comando
	host[MAXHOSTNAMELEN] = "\0",	// host
	buf[BUFLMAX];			// buffer per l'I/O

int	sd,				// socket descriptor
	sas,				// socket address size
	bufl,				// dati letti dal buffer buf
	a1,a2,a3,a4;			// per eventuali host numerici

struct	sockaddr_in sa;			// indirizzo del socket
struct	hostent *he;			// informazioni sull'host


// un po' di controlli sui parameti passati...
if ( argc != 3) {
	help();
	printf("\nnumero di parametri errato\n");
	exit(OERR);
} else {
	// non serve tediarsi con il /0 finale, arriva gratis
	strncat((char *)&host, argv[1], MAXHOSTNAMELEN-1);
	strncat((char *)&cmd, argv[2], CLEN-1);
}
#ifdef DEBUG
	printf("client: comando %s, host %s\n",cmd,host);
#endif


// smanetto un po' con i parametri...
if (sscanf(host,"%d.%d.%d.%d",&a1,&a2,&a3,&a4) == 4)
	// sembra proprio un host numerico...
	sa.sin_addr.s_addr=inet_addr(host);
else if ( (he = gethostbyname(host)) == NULL ) {
	perror("client: non riesco a determinare l'indirizzo!");
	exit (OCERR);
}
// inizializzo le variabili
sa.sin_family 	= AF_INET;
sa.sin_port	= htons(PORT);
memcpy(&sa.sin_addr,he->h_addr,he->h_length);
sas = sizeof(sa);
#ifdef DEBUG
printf("client: TCP, host %s (IP %s), porta %d\n",host,inet_ntoa(sa.sin_addr),(int)ntohs(sa.sin_port));
#endif

// creo un socket
if ( (sd = socket (AF_INET, SOCK_STREAM, 0)) < 0 ) {
	perror("client: erore facendo socket");
	exit(CDERR);
}
#ifdef DEBUG
printf("client: socket aperto, SD=%u\n",sd);
#endif

// ottimo, ho tutto quello che mi serve, passo a connettermi
if (connect(sd, (struct sockaddr *)&sa, sas) < 0) {
	perror("client: errore facendo connect");
	exit(OCERR);
}
#ifdef DEBUG
printf("client: connessione stabilita\n");
#endif

// ora scrivo sul socket la stringa di comando...
if ( write(sd, &cmd, strlen(cmd)) != strlen(cmd) ){
	perror("client: errore scrivendo sul socket");
	exit(RWERR);
}
#ifdef DEBUG
printf("client: scritto comando %s\n", cmd);
#endif

// leggo quello che mi arriva e lo sparo cosi` com'e` in uscita
do {
	bufl=read(sd, &buf, BUFLMAX);
	if ( bufl > 0 )
		write(STDOUT,&buf,bufl);
} while ( bufl > 0 );	// notare che la condizione e` diversa da quella UDP
			// questo perche` e` proprio diversa la gestione
			// della condizione di ``fine dati''

// un po' di pulizia, non devo fare altro...
shutdown(sd,2);
close(sd);

#ifdef DEBUG
printf("client: esco\n");
#endif

} // main()
