#include <string.h>
#include "parser.h"

/*
parser.c
	stupido parser che controlla se un comando e` valido

Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/


// ritorna il numero del comando se c e` un comando valido
int parse (char *c) {

int i = 0;

while (( strncmp(c,cmds[i],strlen(cmds[i])) != 0 ) && ( i < PCMD ))
	i++;

if (i < PCMD)
	return (i+1);
else
	return 0;

} // parse()


// dato un numero di comando ritorna il path da eseguire; la figata e` che
// io non vando *MAI* ad eseguire delle stringhe passate in qualche maniera,
// ma *SOLO* delle stringhe definite static in config.h
// massima sicurezza.
char *getcmd (int i) {

if (( i > 0 ) && ( i <= PCMD ))
	return cmdpath[i-1];
else
	return "\0";

} // getcmd()


// dato un numero di comando ritorna il suo ``nome'' cosi` come definito
// sul parser (in pratica la stringa che viene ``parsata''
char *cmdname (int i) {

if (( i > 0 ) && ( i <= PCMD ))
	return cmds[i-1];
else
	return "\0";

} // getcmd()
